-- additional functions for table manipulation 
--  
-- functional programming in Lua 
--[[ Functional programming in Lua ]]

function fun.map (tab, f)
    local mapped = {}
        for k, v in pairs(tab) do
            mapped[k] = f(v)
        end
return mapped
end

function fun.filter (tab, f)
 	local fil= {}
 	    for k, v in pairs (tab) do
 	        if f(v) then
 	            fil[k] = v
 	        end
 	    end
 	return fil
end

 -- foldr(function, default_value, table)
 -- e.g: foldr({1,2,3,4,5},*, 1) -> 120
 
 function fun.foldr(tab, f, val)
     for k,v in pairs(tab) do
         val = f(val, v)
     end
     return val
 end